//*********************** Première fenêtre *****************************
//**********************************************************************

// *********** Cadre *************
plot2d(0,0,-1,"012","",[0,0,30,30]);




// *********** Titre **************
titlepage(["Urne de Bernoulli"])



//*****  Inscritptions au desus de la fenêtre     

xtitle("(cliquer dans la fenetre pour lancer l''animation)")
[c_i,c_x,c_y,c_w]=xclick(); 


// *** Initialisation du générateur de nombres aléatoire grâce à la date système                 
rand('seed',getdate('s'));


//***** Effaçage de la fenêtre  ******
clf();



//*********************************************************************
//*********************** Deuxième fenêtre ****************************
//*********************************************************************


// *************************** Cadre **********************************

plot2d(0,0,-1,"012","",[0,0,30,30],axesflag=2);



// ************************** Triangle ********************************


// Polygone régulier à 3 côtés
// contenu dans le cercle de centre (15,11), de rayon 15
// Puis rotation d'angle pi/2

xrpoly([15,11],3,15,%pi/2)



T=gce()        // Le triangle est affecté à l'entité T

T.thickness=2  // Epaisseur du triangle


// *********************** Sommets du triangle *************************

// Sommet B : Boules bleues

B=[15,26];    // Coordonnées du point B

// On trace un secteur de cercle  contenu dans 
// le carré de coin inférieur gauche en (14,27)
// de largeur 2 (et de longueur 2)
// Le secteur "débute" à 300° et parcourt 300°
xfarc(14,27,2,2,64*300,64*300)
b=gce()         // Le secteur tracé est affecté à l'entité b
b.background=12 // On colorie le secteur en bleu

// Sommet R : Boules rouges

R=[15-15*sqrt(3)/2,11-15/2]; // coordonnées du point R 

// On trace un secteur de cercle  contenu dans 
// le carré de coin inférieur gauche en (14-15*sqrt(3)/2,12-15/2)
// de largeur 2 (et de longueur 2)
// Le secteur "débute" à 60° et parcourt 300°
xfarc(14-15*sqrt(3)/2,12-15/2,2,2,64*60,64*300)
r=gce();          // Le secteur tracé est affecté à l'entité r
r.background=20 ; // On colorie le secteur en rouge



// Sommet R : Boules vertes

V=[15+15*sqrt(3)/2,11-15/2]; // coordonnées du point V
// On trace un secteur de cercle  contenu dans 
// le carré de coin inférieur gauche en (14+15*sqrt(3)/2,12-15/2)
// de largeur 2 (et de longueur 2)
// Le secteur "débute" à 180° et parcourt 300°
xfarc(14+15*sqrt(3)/2,12-15/2,2,2,64*180,64*300);

v=gce();// Le secteur tracé est affecté à l'entité v
v.background=13;// On colorie le secteur en vert


// On demande le nombre de tirages voulu
conditions=x_mdialog('Conditions de l''expérience',['nombre de tirages successifs','Nombre de billes bleues','Nombre de billes rouges','Nombre de billes vertes'],['10','1','1','1'])//=input("Nombre de tirages")
// On enregistre la valeur donnée par l'utilisateur dans la variable n_tirage
n_tirage=evstr(conditions(1));
nb=evstr(conditions(2)); // Nombre de boules bleues
nr=evstr(conditions(3)); // nombres de boules rouges
nv=evstr(conditions(4)); // nombre de boules vertes


n_total=nb+nr+nv;
n_total_tir=nb+nr+nv;
pb=nb/n_total; // probabilité de tirer une boule bleue
pr=nr/n_total; // probabilité de tirer une boule rouge
pv=nv/n_total; // probabilité de tirer une boule verte

// On trace le point G, centre de gravité des 
// trois sommets affectés des masses choisies

G=[pb*B(1)+pr*R(1)+pv*V(1),pb*B(2)+pr*R(2)+pv*V(2)];
plot2d(G(1),G(2),-1,axesflag=2);


// Affichage nombre boules bleues aux point de coordonnées (15,28)
xstring(15,28,string(nb));
af_b=gce();

// Affichage nombre boules rouges aux point de coordonnées (14-15*sqrt(3)/2,13-15/2)
xstring(14-15*sqrt(3)/2,13-15/2,string(nr));
af_r=gce();

// Affichage nombre boules vertes aux point de coordonnées (16+15*sqrt(3)/2,13-15/2)
xstring(16+15*sqrt(3)/2,13-15/2,string(nv)) 
af_v=gce();




// On définie un temps de pause en fonction du nombre de tirages
// Si on a moins de 15 tirages la pause sera de 1 seconde entre chaque tirage
// Sinon, elle sera de 0,001 seconde
if n_tirage<15 then pause=1000000;
    else pause=100;
end


// Pour i allant de 1 au nombre de tirages souhaité
for i=1:n_tirage,
    G1=G; // On mémorise les coordonnées du point G dans l'entité G1
    
    couleur=rand(1); // Prend une valeur réelle entre 0 et 1 la couleur dépend de cette valeur
    xpause(pause); // On marque la pause pour mieux voir l'animation
   
    if couleur<=pb then     // Si la valeur aléatroire choisie par l'ordinateur 
                            //est comprise entre 0 et la probabilité de tirer une boule bleue, alors
        nb=nb+1;       // Le nombre de boule bleue augmente
        b.background=8 // la boule bleue clignotte
        b.background=12 
        b.background=8
        b.background=12

        af_b.font_foreground=8; // On efface l'ancienne valeur affichée au sommet bleu

        xstring(15,28,string(nb));
        af_b=gce(); // Affichage nb boules bleues

    else if couleur<=pb+pr then
              nr=nr+1;
              r.background=8 // la boule rouge clignotte
              r.background=20
              r.background=8
              r.background=20

              af_r.font_foreground=8; // On efface l'ancienne valeur affichée au sommet rouge
              xstring(14-15*sqrt(3)/2,13-15/2,string(nr)); // on affiche la nouvelle valeur du nombre de boules rouges

              af_r=gce(); // On prend en compte la nouvelle valeur du nb de boules rouges tirées
         else nv=nv+1;
              v.background=8 // la boule verte clignotte
              v.background=13
              v.background=8
              v.background=13

              af_v.font_foreground=8; // On efface l'ancienne valeur affichée au sommet vert
              xstring(16+15*sqrt(3)/2,13-15/2,string(nv)) // on affiche la nouvelle valeur du nombre de boules vertes
              af_v=gce(); // On prend en compte la nouvelle valeur du nb de boules vertes 

         end
      
    end
    n_total_tir=n_total_tir+1; // Le nombre de boules totale tirée augmente d'autant de boules remises
    pb_t=nb/n_total_tir; // probabilité de tirer une boule bleue change
    pr_t=nr/n_total_tir; // probabilité de tirer une boule rouge change
    pv_t=nv/n_total_tir; // probabilité de tirer une boule noire change
    G=[pb_t*B(1)+pr_t*R(1)+pv_t*V(1),pb_t*B(2)+pr_t*R(2)+pv_t*V(2)]; // On calcule les nouvelles coordonnées de G
    plot2d(G(1),G(2),0,axesflag=2); // On trace le nouveau centre de gravité G

    xpause(pause/2); // On effectue une pause avant de tracer le segment
    xsegs([G1(1),G(1)],[G1(2),G(2)]); // ontrace le segment entre le nouveau centre de gravité et l'ancien


end
if n_tirage > 30 

end
