//*********************** Première fenêtre *****************************
//**********************************************************************

// *********** Cadre *************
plot2d(0,0,-1,"012","",[0,0,30,30]);


// *********** Titre **************
titlepage(["Urne de Polya"])


//*****  Inscritptions au desus de la fenêtre     
xtitle("(cliquer dans la fenetre pour lancer l''animation)")
[c_i,c_x,c_y,c_w]=xclick(); 



// *** Initialisation du générateur de nombres aléatoire grâce à la date système                 
rand('seed',getdate('s'));


//***** Effaçage de la fenêtre  ******
clf();


//*********************************************************************
//*********************** Deuxième fenêtre ****************************
//*********************************************************************


// *************************** Cadre **********************************

plot2d(0,0,-1,"012","",[0,0,30,30],axesflag=2);



// ************************** Triangle ********************************


// Polygone régulier à 3 côtés
// contenu dans le cercle de centre (15,11), de rayon 15
// Puis rotation d'angle pi/2

xrpoly([15,11],3,15,%pi/2)

T=gce()        // Le triangle est affecté à l'entité T
T.thickness=2  // Epaisseur du triangle


// *********************** Sommets du triangle *************************

// Sommet B : Boules bleues

B=[15,26];    // Coordonnées du point B

// On trace un secteur de cercle  contenu dans 
// le carré de coin inférieur gauche en (14,27)
// de largeur 2 (et de longueur 2)
// Le secteur "débute" à 300° et parcourt 300°
xfarc(14,27,2,2,64*300,64*300)
b=gce()         // Le secteur tracé est affecté à l'entité b
b.background=12 // On colorie le secteur en bleu

// Sommet R : Boules rouges

R=[15-15*sqrt(3)/2,11-15/2]; // coordonnées du point R 

// On trace un secteur de cercle  contenu dans 
// le carré de coin inférieur gauche en (14-15*sqrt(3)/2,12-15/2)
// de largeur 2 (et de longueur 2)
// Le secteur "débute" à 60° et parcourt 300°
xfarc(14-15*sqrt(3)/2,12-15/2,2,2,64*60,64*300)
r=gce();          // Le secteur tracé est affecté à l'entité r
r.background=20 ; // On colorie le secteur en rouge



// Sommet R : Boules vertes

V=[15+15*sqrt(3)/2,11-15/2]; // coordonnées du point V
// On trace un secteur de cercle  contenu dans 
// le carré de coin inférieur gauche en (14+15*sqrt(3)/2,12-15/2)
// de largeur 2 (et de longueur 2)
// Le secteur "débute" à 180° et parcourt 300°
xfarc(14+15*sqrt(3)/2,12-15/2,2,2,64*180,64*300);

v=gce();// Le secteur tracé est affecté à l'entité v
v.background=13;// On colorie le secteur en vert




// On demande le nombre de tirages voulu
conditions=x_mdialog('Conditions de l''expérience',['nombre de tirages successifs','Nombre de séries de tirages','Nombre de billes bleues','Nombre de billes rouges','Nombre de billes vertes','Nombre de boules ajoutées à la remise'],['150','200','1','1','1','1'])//=input("Nombre de tirages")
// On enregistre la valeur donnée par l'utilisateur dans la variable n_tirage
n_tirage=evstr(conditions(1)); // Nombre de tirages à chaque série
n_series=evstr(conditions(2)); // Nombre de séries de n tirages
nb=evstr(conditions(3)); // Nombre de boules bleues
nr=evstr(conditions(4)); // nombres de boules rouges
nv=evstr(conditions(5)); // nombre de boules vertes
remise=evstr(conditions(6)); // nombre de boules vertes

n_total=nb+nr+nv;
pb=nb/n_total; // probabilité de tirer une boule bleue
pr=nr/n_total; // probabilité de tirer une boule rouge
pv=nv/n_total; // probabilité de tirer une boule verte


// Affichage nombre boules bleues au point de coordonnées (15,28)
xstring(15,28,string(nb));


// Affichage nombre boules rouges au point de coordonnées (14-15*sqrt(3)/2,13-15/2)
xstring(14-15*sqrt(3)/2,13-15/2,string(nr));


// Affichage nombre boules vertes au point de coordonnées (16+15*sqrt(3)/2,13-15/2)
xstring(16+15*sqrt(3)/2,13-15/2,string(nv)) 


// Affichage nombre de boules remises au point de coordonnées (1,20)
xstring(1,20,'Remise de '+string(remise)+' boule(s)') 


for j=1:n_series
// On enregistre la valeur donnée par l'utilisateur dans la variable n_tirage
n_tirage=evstr(conditions(1)); // Nombre de tirages à chaque série
n_series=evstr(conditions(2)); // Nombre de séries de n tirages
nb=evstr(conditions(3)); // Nombre de boules bleues
nr=evstr(conditions(4)); // nombres de boules rouges
nv=evstr(conditions(5)); // nombre de boules vertes
remise=evstr(conditions(6)); // nombre de boules vertes

n_total=nb+nr+nv;
pb=nb/n_total; // probabilité de tirer une boule bleue
pr=nr/n_total; // probabilité de tirer une boule rouge
pv=nv/n_total; // probabilité de tirer une boule verte


// Pour i allant de 1 au nombre de tirages souhaité
   for i=1:n_tirage,
        
        couleur=rand(1); // Prend une valeur réelle entre 0 et 1 la couleur dépend de cette valeur
       
        if couleur<=pb then     // Si la valeur aléatroire choisie par l'ordinateur 
                                //est comprise entre 0 et la probabilité de tirer une boule bleue, alors
             nb=nb+remise;       // Le nombre de boule bleue augmente
        else if couleur<=pb+pr then
                  nr=nr+remise;
             else nv=nv+remise;
             end
          
        end
    n_total=n_total+remise; // Le nombre de boules totale augmente d'autant de boules remises
    pb=nb/n_total; // probabilité de tirer une boule bleue change
    pr=nr/n_total; // probabilité de tirer une boule rouge change
    pv=nv/n_total; // probabilité de tirer une boule noire change


   end
    G=[pb*B(1)+pr*R(1)+pv*V(1),pb*B(2)+pr*R(2)+pv*V(2)]; // On calcule les dernières coordonnées de G
   plot2d(G(1),G(2),-10,axesflag=2);
  
end  
